<?php
namespace MINAV\Layersliderlight\Domain\Model;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013
 *  Manfred Rutschmann <rutschmann@agentur-volumen.de>, VOLUMEN Werbe-/Internetagentur
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 *
 *
 * @package layersliderlight
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 or later
 *
 */
class Slide extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {

	/**
	 * Title of this slide
	 *
	 * @var \string
	 */
	protected $title;


    /**
     *  The formitems
     *
     *  @var \array
     */
    protected $formitems;
    
    /**
     * slider
     *
     * @var \MINAV\Layersliderlight\Domain\Model\Slider
     */
    protected $slider;    

        
    /**
     *  The Sorting
     * 
     *  @var \int
     */    
    protected $sorting;

        
    /**
     *  The Configuration
     * 
     *  @var \string
     */    
    protected $configuration;

    /**
     * The image
     *
     * @var \string
     */
    protected $image;
    

	/**
	 * __construct
	 *
	 * @return Slide
	 */
	public function __construct() {
		//Do not remove the next line: It would break the functionality
		$this->initStorageObjects();
	}

	/**
	 * Initializes all ObjectStorage properties.
	 *
	 * @return void
	 */
	protected function initStorageObjects() {


	}

	/**
	 * Returns the title
	 *
	 * @return \string $title
	 */
	public function getTitle() {
		return $this->title;
	}

	/**
	 * Sets the title
	 *
	 * @param \string $title
	 * @return void
	 */
	public function setTitle($title) {
		$this->title = $title;
	}

    /**
     * Returns the slider
     *
     * @return \MINAV\Layersliderlight\Domain\Model\Slider $slider
     */
    public function getSlider() {
        return $this->slider;
    }

    /**
     * Sets the slides
     *
     * @param \MINAV\Layersliderlight\Domain\Model\Slider $slider
     * @return void
     */
    public function setSlider(\MINAV\Layersliderlight\Domain\Model\Slider $slider) {
        $this->slider = $slider;
    }    

    /**
     * Returns the Sorting
     *
     * @return \int $sorting
     */
    public function getSorting() {
        return $this->sorting;
    }
    
    /**
     * Sets the Sorting
     *
     * @param \int $sorting
     * @return void
     */
    public function setSorting($sorting) {
        $this->sorting = $sorting;
    }


    /**
     * Returns the Configuration
     *
     * @return \array $configuration
     */
    public function getConfiguration() {
        return json_decode($this->configuration, true);
    }
    
    /**
     * Sets the Configuration
     *
     * @param \string $configuration
     * @return void
     */
    public function setConfiguration($configuration) {
        $this->configuration = json_encode($configuration);
    }

    /**
     * Returns the image
     *
     * @return \string $image
     */
    public function getImage() {
        return $this->image;
    }

    /**
     * Sets the Image
     *
     * @param \string $image
     * @return void
     */
    public function setImage($image) {
        $this->image = $image;
    }

    /**
     * Returns the Formitems
     *
     * @return \array $formitems
     */
    public function getFormitems() {
        return $this->formitems;
    }

    /**
     * Sets the Formitems
     *
     * @param \array $formitems
     * @return void
     */
    public function setFormitems($formitems) {
        $this->formitems = $formitems;
    }    


}
?>